
# autopilot for L410

nav_armed=0;
apr_armed=0;
gs_armed=0;
alt_armed=0; alt_alert_disp_timeout=0;
cws_btn_pressed=0;

modulo = func {
	r = arg[0] / arg[1];
	i = int (r);
	r = r - i;
	r = r * arg[1];
	return r;
}

#numbers:

inc_value_fine() = func {
    if (getprop("/instrumentation/autopilot/as-vs-sw")==1) {
        vs=getprop("/instrumentation/autopilot/selected-vs");
        vs = int(vs/100)*100;
        if (vs+100 > 5000) {
            vs=4900;
        }
        setprop("/instrumentation/autopilot/selected-vs",vs+100);
        setprop("/instrumentation/autopilot/as-vsdispl",1);
    } else {
        alt=getprop("/instrumentation/autopilot/selected-alt");
        if (alt+100 > 50000) {
            alt=49900;
        }
        setprop("/instrumentation/autopilot/selected-alt",alt+100);
        setprop("/instrumentation/autopilot/as-vsdispl",0);
    }
}

dec_value_fine() = func {
    if (getprop("/instrumentation/autopilot/as-vs-sw")==1) {
        vs=getprop("/instrumentation/autopilot/selected-vs");
        vs = int(vs/100)*100;
        if (vs-100 < -5000) {
            vs=-4900;
        }
        setprop("/instrumentation/autopilot/selected-vs",vs-100);
        setprop("/instrumentation/autopilot/as-vsdispl",1);
    } else {
        alt=getprop("/instrumentation/autopilot/selected-alt");
        if (alt-100 < 0) {
            alt=100;
        }
        setprop("/instrumentation/autopilot/selected-alt",alt-100);
        setprop("/instrumentation/autopilot/as-vsdispl",0);
    }
}

inc_value() = func {
    if (getprop("/instrumentation/autopilot/as-vs-sw")==1) {
        vs=getprop("/instrumentation/autopilot/selected-vs");
        vs = int(vs/100)*100;
        if (vs+1000 > 5000) {
            vs=4000;
        }
        setprop("/instrumentation/autopilot/selected-vs",vs+1000);
        setprop("/instrumentation/autopilot/as-vsdispl",1);
    } else {
        alt=getprop("/instrumentation/autopilot/selected-alt");
        if (alt+1000 > 50000) {
            alt=49000;
        }
        setprop("/instrumentation/autopilot/selected-alt",alt+1000);
        setprop("/instrumentation/autopilot/as-vsdispl",0);
    }
}

dec_value() = func {
    if (getprop("/instrumentation/autopilot/as-vs-sw")==1) {
        vs=getprop("/instrumentation/autopilot/selected-vs");
        vs = int(vs/100)*100;
        if (vs-1000 < -5000) {
            vs=-4000;
        }
        setprop("/instrumentation/autopilot/selected-vs",vs-1000);
        setprop("/instrumentation/autopilot/as-vsdispl",1);
    } else {
        alt=getprop("/instrumentation/autopilot/selected-alt");
        if (alt-1000 < 0) {
            alt=1000;
        }
        setprop("/instrumentation/autopilot/selected-alt",alt-1000);
        setprop("/instrumentation/autopilot/as-vsdispl",0);
    }
}

#buttons:

activate_fd() = func () {
    if (getprop("/instrumentation/autopilot/mode-fd-on")==0) {
        setprop("/autopilot/settings/target-pitch-deg",getprop("/orientation/pitch-deg"));
    }
    setprop("/instrumentation/autopilot/mode-fd-on",1);
}
deactivate_fd() = func {
    setprop("/instrumentation/autopilot/mode-fd-on",0);
    setprop("/instrumentation/autopilot/mode-ap-on",0);
}

activate_ap() = func {
    setprop("/instrumentation/autopilot/mode-ap-on",1);
}
deactivate_ap() = func {
    setprop("/instrumentation/autopilot/mode-ap-on",0);
}

activate_alt() = func {
    setprop("/instrumentation/autopilot/mode-alt-on",1);
    deactivate_apr();
    alt_armed=0;
}
deactivate_alt() = func {
    setprop("/instrumentation/autopilot/mode-alt-on",0);
    setprop("/autopilot/settings/target-pitch-deg",getprop("/orientation/pitch-deg"));
}

activate_hdg() = func {
    setprop("/instrumentation/autopilot/mode-hdg-on",1);
    deactivate_nav();
    deactivate_apr();
}
deactivate_hdg() = func {
    setprop("/instrumentation/autopilot/mode-hdg-on",0);
}

activate_nav() = func {
    deactivate_hdg();
    deactivate_apr();
    setprop("/instrumentation/autopilot/mode-nav-on",1);
}
deactivate_nav() = func {
    setprop("/instrumentation/autopilot/mode-nav-on",0);
    nav_armed=0;
}

activate_apr() = func {
    deactivate_hdg();
    deactivate_nav();
    setprop("/instrumentation/autopilot/mode-apr-on",1);
}
deactivate_apr() = func {
    setprop("/instrumentation/autopilot/mode-apr-on",0);
    apr_armed=0;
    gs_armed=0;
    setprop("/autopilot/settings/target-pitch-deg",getprop("/orientation/pitch-deg"));
}


fd_btn() = func {
    if (getprop("/systems/electrical/outputs/autopilot")>10) { 
        if (getprop("/instrumentation/autopilot/mode-fd-on")==1) {
            deactivate_fd();
        } else {
            activate_fd();
        }
    }
}

ap_btn() = func {
    if (getprop("/systems/electrical/outputs/autopilot")>10) { 
        if (getprop("/instrumentation/autopilot/mode-fd-on")==1) {
            if (getprop("/instrumentation/autopilot/mode-ap-on")==0) {
                activate_fd();
                activate_ap();
            } else {
                deactivate_ap();
            }
        }
    }
}

alt_btn() = func {
    if (getprop("/systems/electrical/outputs/autopilot")>10) { 
        if (getprop("/instrumentation/autopilot/mode-alt-on")==1) {
            deactivate_alt();
        } else {
            activate_fd();
            activate_alt();
            setprop("/autopilot/settings/target-altitude-ft",getprop("/instrumentation/altimeter/indicated-altitude-ft"));
        }
    }    
}

hdg_btn() = func {
    if (getprop("/systems/electrical/outputs/autopilot")>10) { 
        if (getprop("/instrumentation/autopilot/mode-hdg-on")==1) {
            deactivate_hdg();
        } else {
            activate_fd();
            activate_hdg();
        }
    }
}

nav_btn() = func {
    if (getprop("/systems/electrical/outputs/autopilot")>10) { 
        if (getprop("/instrumentation/autopilot/mode-nav-on")==1) {
            deactivate_nav();
        } else {
            activate_fd();
            setprop("/instrumentation/autopilot/mode-nav-on",1);
            nav_armed=1;
            deactivate_apr();
        }
    }
}

apr_btn() = func {
    if (getprop("/systems/electrical/outputs/autopilot")>10) { 
        if (getprop("/instrumentation/autopilot/mode-apr-on")==1) {
            deactivate_apr();
        } else {
            activate_fd();
            setprop("/instrumentation/autopilot/mode-apr-on",1);
            apr_armed=1;
            gs_armed=1;
            deactivate_nav();
        }
    }
}

as_alt_btn() = func {
    if (getprop("/systems/electrical/outputs/autopilot")>10) { 
        if (alt_armed==0) {
            alt_armed=1;
            deactivate_alt();
        } else {
            alt_armed=0;
            setprop("/autopilot/settings/target-pitch-deg",getprop("/orientation/pitch-deg"));
        }
    }
}

cws_btn() = func {
    cws_btn_pressed=1;
    activate_fd();
}

cws_btn_modup() = func {
    cws_btn_pressed=0;
    if (getprop("/instrumentation/autopilot/mode-alt-on")) {
        setprop("/autopilot/settings/target-altitude-ft",getprop("/instrumentation/altimeter/indicated-altitude-ft"));
    } else {
        setprop("/autopilot/settings/target-pitch-deg",getprop("/orientation/pitch-deg"));
    }
}

ap_disconnect_btn() = func{
    deactivate_ap();
    deactivate_fd();
    deactivate_alt();
    deactivate_apr();
    deactivate_hdg();
    deactivate_nav();
}

autopilot_75ms = func {
    alt_req=0; vspeed=1;
    if (getprop("/instrumentation/autopilot/ann-alt-on")==1) {
        alt_req=getprop("/autopilot/internal/target-climb-rate-fps");
    } else {
    if (getprop("/instrumentation/autopilot/ann-apr-gs-on")==1) {
        alt_req=getprop("/instrumentation/nav[0]/gs-rate-of-climb");
    } else {
        alt_req=getprop("/autopilot/settings/target-pitch-deg");
        vspeed=0;
    }}
    
    hdg_req=0;
#    if (getprop("/instrumentation/autopilot/ann-hdg-on")==1 or
#        (getprop("/instrumentation/autopilot/ann-apr-on")==1 and getprop("/instrumentation/autopilot/ann-apr-arm-on")==0) or
#        (getprop("/instrumentation/autopilot/ann-nav-on")==1 and getprop("/instrumentation/autopilot/ann-nav-arm-on")==0)) {
        hdg_req=getprop("/autopilot/internal/target-roll-deg");
#    }
    
    setprop("/instrumentation/autopilot/requested_roll_ind",hdg_req);
    setprop("/instrumentation/autopilot/requested_pitch",alt_req);
    
    if (vspeed==1) {
        vsn = -( alt_req - getprop("/velocities/vertical-speed-fps") ) * 0.6;
        setprop("/instrumentation/autopilot/requested_pitch_ind",vsn);
    } else {
        vsn = -( alt_req - getprop("/orientation/pitch-deg") ) * 3;
        setprop("/instrumentation/autopilot/requested_pitch_ind",vsn);
    }
    
    settimer ( autopilot_75ms , 0.075 );
}

autopilot_300ms = func {
    
    # check power on
    fd_required_on = 1; 
    if (getprop("/systems/electrical/outputs/autopilot")<10) { 
        fd_required_on = 0; 
        setprop("/instrumentation/autopilot/mode-ap-on",0);
        setprop("/instrumentation/autopilot/mode-fd-on",0);
        setprop("/instrumentation/autopilot/mode-alt-on",0);
        setprop("/instrumentation/autopilot/mode-hdg-on",0);
        setprop("/instrumentation/autopilot/mode-nav-on",0);
        setprop("/instrumentation/autopilot/mode-apr-on",0);
    }
    # tady se pridaji dalsi podminky na vsechny pristroje, ktere musi fungovat, aby bylo mozne zapnout autopilota

    if (fd_required_on == 0) {
        deactivate_fd();
    }

    ann_fd = 0;
    ann_ap = 0;
    ann_alt = 0;
    ann_hdg = 0;
    ann_nav = 0;
    ann_nav_arm = 0;
    ann_apr = 0;
    ann_apr_arm = 0;
    ann_apr_gs = 0;
    ann_apr_ga = 0;
    ann_as_capture = 0;
    
    if (getprop("/instrumentation/autopilot/mode-fd-on")==1) { ann_fd=1; }
    if (getprop("/instrumentation/autopilot/mode-ap-on")==1) { ann_ap=1; }

    current_heading_mode="wing-leveler";
    current_altitude_mode="pitch-hold";
    
        #je-li aktivni computer autopilota:

        if (getprop("/instrumentation/autopilot/mode-alt-on")==1) { 
            ann_alt=1; 
            current_altitude_mode="altitude-hold";
        }
        if (getprop("/instrumentation/autopilot/mode-hdg-on")==1) { 
            ann_hdg=1; 
            current_heading_mode="dg-heading-hold";
        }

        if (getprop("/instrumentation/autopilot/mode-nav-on")==1) { 
            ann_nav=1;
            if (nav_armed==1) {
                ann_nav_arm = 1;
                if (getprop("/instrumentation/nav[0]/in-range")==1) {
                    if (abs(getprop("/instrumentation/nav[0]/crosstrack-error-m"))<900) {
                        #pri priblizeni na 0.5 NM k radiale se prepne na aktivni
                        nav_armed=0;
                        deactivate_hdg();
                    }
                }
            }
            if (nav_armed==0) {
                current_heading_mode="nav1-hold";
            }
        }

        if (getprop("/instrumentation/autopilot/mode-apr-on")==1) { 
            ann_apr=1;
            if (apr_armed==1) {
                ann_apr_arm = 1;
                if (getprop("/instrumentation/nav[0]/in-range")==1) {
                    if (abs(getprop("/instrumentation/nav[0]/crosstrack-error-m"))<1100) {
                        #pri priblizeni na 0.5 NM k radiale se prepne na aktivni
                        apr_armed=0;
                        deactivate_hdg();
                    }
                }
            }
            if (apr_armed==0) {
                current_heading_mode="nav1-hold";
            }
            
            if (gs_armed==1) {
                ann_apr_ga = 1;
                if (getprop("/instrumentation/nav[0]/in-range")==1 and
                    getprop("/instrumentation/nav[0]/has-gs")==1) {
                    if (getprop("/instrumentation/nav[0]/gs-needle-deflection")<1) {
                        #pri priblizeni pod +1 stupne k sestupovemu paprsku
                        gs_armed=0;
                        deactivate_alt();
                    }
                }
            }
            if (gs_armed==0) {
                ann_apr_gs = 1;
                current_altitude_mode="gs1-hold";
                alt_armed=0;
            }
        }


    #zobrazeni a zpracovani selektoru vysky:

    sel_alt = getprop("/instrumentation/autopilot/selected-alt");
    # setprop("/autopilot/settings/target-altitude-ft",sel_alt);
    if (abs(sel_alt-getprop("/instrumentation/altimeter/indicated-altitude-ft"))<20) {
        if (alt_armed==1) {
            setprop("/instrumentation/autopilot/as-alert-flag",1);
            settimer( autopilot_alert_off, 1.5);
            setprop("/autopilot/settings/target-altitude-ft",getprop("/instrumentation/autopilot/selected-alt"));
            activate_alt();
            alt_alert_disp_timeout=1;
        }
    }
    if ((abs(sel_alt-getprop("/instrumentation/altimeter/indicated-altitude-ft"))<1000 and 
        abs(sel_alt-getprop("/instrumentation/altimeter/indicated-altitude-ft"))>300  and
        alt_armed==1) 
        or
        (abs(getprop("/autopilot/settings/target-altitude-ft")-getprop("/instrumentation/altimeter/indicated-altitude-ft"))<1000 and 
        abs(getprop("/autopilot/settings/target-altitude-ft")-getprop("/instrumentation/altimeter/indicated-altitude-ft"))>300  and
        ann_alt==1 )) {
        setprop("/instrumentation/autopilot/as-alert-flag",1);
    } else {
        if (alt_alert_disp_timeout==0) {
            setprop("/instrumentation/autopilot/as-alert-flag",0);
        }
    }
    if (abs(sel_alt-getprop("/instrumentation/altimeter/indicated-altitude-ft"))<200 and 
        abs(sel_alt-getprop("/instrumentation/altimeter/indicated-altitude-ft"))>20  and
        alt_armed==1) {
        ann_as_capture = 1;
        setprop("/autopilot/settings/target-altitude-ft",getprop("/instrumentation/autopilot/selected-alt"));
        current_altitude_mode="altitude-hold";
    }

    #zobrazeni aktualnich hodnot:

    setprop("/instrumentation/autopilot/ann-fd-on",ann_fd);
    setprop("/instrumentation/autopilot/ann-ap-on",ann_ap);
    setprop("/instrumentation/autopilot/ann-alt-on",ann_alt);
    setprop("/instrumentation/autopilot/ann-hdg-on",ann_hdg);
    setprop("/instrumentation/autopilot/ann-nav-on",ann_nav);
    setprop("/instrumentation/autopilot/ann-nav-arm-on",ann_nav_arm);
    setprop("/instrumentation/autopilot/ann-apr-on",ann_apr);
    setprop("/instrumentation/autopilot/ann-apr-arm-on",ann_apr_arm);
    # setprop("/instrumentation/autopilot/ann-apr-ga-on",ann_apr_ga);
    setprop("/instrumentation/autopilot/ann-apr-gs-on",ann_apr_gs);
    setprop("/instrumentation/autopilot/as-arm-flag",alt_armed);
    setprop("/instrumentation/autopilot/as-capture-flag",ann_as_capture);

    setprop("/autopilot/locks/heading",current_heading_mode);
    setprop("/autopilot/locks/altitude",current_altitude_mode);
    
    if (ann_ap==1 and cws_btn_pressed==0) {
        setprop("/autopilot/locks/heading-ap",current_heading_mode);
        setprop("/autopilot/locks/altitude-ap",current_altitude_mode);
    } else {
        setprop("/autopilot/locks/heading-ap","none");
        setprop("/autopilot/locks/altitude-ap","none");
    }

    settimer ( autopilot_300ms , 0.3 );
    
    return;



    if (getprop("/instrumentation/autopilot/mode-ap-on")==1) {
        # pokud je zapnuty mod autopilota:
        
        ann_ap=1;
    }
    sel_alt = getprop("/instrumentation/autopilot/selected-alt");
        
    if (getprop("/systems/electrical/outputs/autopilot")>10) { 
        if (getprop("/instrumentation/autopilot/mode-alt-on")==1) {
            #nastaveni vysky je zapnuto
            if (sel_alt>0) {
                #a je zadana nejaka vyska
                ann_alt=1;
            }
        }
        if (getprop("/instrumentation/autopilot/mode-hdg-on")==1) {
            #nastaveni kurzu podle HSI je zapnuto
            ann_hdg=1;
        }
        if (getprop("/instrumentation/autopilot/mode-nav-on")==1) {
            #nastaveni kurzu podle NAV/VOR-LOC je zapnuto
            ann_nav=1;
        }
        if (getprop("/instrumentation/autopilot/mode-apr-on")==1) {
            #nastaveni kurzu podle NAV/ILS je zapnuto
            ann_apr=1;
        }
    }
    
    if (abs(getprop("/autopilot/internal/nav1-course-error"))<8 and abs(getprop("/autopilot/internal/nav1-heading-error-deg"))<1 or ann_nav==0) {
        setprop("/instrumentation/autopilot/ann-nav-arm-on",0);
    }

    if ((ann_alt==1 or ann_as_capture==1) and ann_ap==1) {
        # setprop("/autopilot/settings/target-altitude-ft",sel_alt);
        setprop("/autopilot/locks/altitude","altitude-hold");
    } else { if (ann_apr==1 and ann_ap==1) {
        setprop("/autopilot/locks/altitude","gs1-hold");
    } else {
        setprop("/autopilot/locks/altitude","");
    }}
    if (ann_hdg==1 and ann_ap==1) {
        setprop("/autopilot/locks/heading","dg-heading-hold");
    } else { if (ann_nav==1 and ann_ap==1) {
        setprop("/autopilot/locks/heading","nav1-hold");
    } else { if (ann_apr==1 and ann_ap==1) {
        setprop("/autopilot/locks/heading","nav1-hold");
    } else {
        setprop("/autopilot/locks/heading","");
    }}}
    setprop("/instrumentation/autopilot/ann-ap-on",ann_ap);
    setprop("/instrumentation/autopilot/ann-alt-on",ann_alt);
    setprop("/instrumentation/autopilot/ann-hdg-on",ann_hdg);
    setprop("/instrumentation/autopilot/ann-nav-on",ann_nav);
    setprop("/instrumentation/autopilot/ann-apr-on",ann_apr);

    settimer ( autopilot_300ms , 0.3 );
}

setprop("/autopilot/settings/target-altitude-ft",0);
setprop("/autopilot/settings/target-pitch-deg",0);
setprop("/velocities/vertical-speed-fps",0);
setprop("/orientation/pitch-deg",0);

settimer ( autopilot_300ms , 10 );
settimer ( autopilot_75ms , 10 );

# vypinace casove omezenych zobrazeni

autopilot_alert_off() = func {
    setprop("/instrumentation/autopilot/as-alert-flag",0);
    alt_alert_disp_timeout=0;
}
